/*
 *Created by wangshengye on 2020/05/07.
 */

#ifndef _DEB_PARSE_H
#define _DEB_PARSE_H
#ifdef __cplusplus
extern "C" {
#endif

#define TEMP_FILE "/tmp/deb.dat"
#define CMDLENGTH (2048)
// the debsig context
struct debsig_ctx {
   const char *deb;
   FILE *deb_fs;
   char originID[2048];
};

struct dpkgArMember {
    struct dpkg_ar_member *next;
    const char *name;
    off_t offset;
    off_t size;
    time_t time;
    mode_t mode;
    uid_t uid;
    gid_t gid;
};

static 
off_t passthrough(FILE *in, FILE *out, off_t len);

off_t checkSigExist(const struct debsig_ctx *ds_ctx, const char *name);

off_t findDebMember(const struct debsig_ctx *ds_ctx, const char *name);
void putDebsign(const char *certfile, const char * name,  char * data, int size);
void  putDebData(FILE* fp, const char * name,  char * data, int size);
void putDebCert(const char* deb, const char * name,  const char *cert_file);
int   getDebData(const char * deb);
int DelCertsign(const struct debsig_ctx *ds_ctx);
int   DebDecompress (const char * debPath, const char * tmpPath);

int   DebCompress (const char * debName, const char * tmpPath);

int ApkDecompress (const char * apkitarname);
int ApkCompress (const char * apkname, const char * signfilename, const char * certfilename);

#ifdef __cplusplus
}
#endif
#endif //_DEB_PARSE_H
